<template>
  <div>
    <el-form ref="dataModel" :model="dataModel" label-width="100px">
      <el-form-item prop="userProfile.image">
        <el-row style="margin-bottom:15px;">
          <el-col :span="24">
            <el-upload
              class="avatar-uploader"
              accept="image/jpeg, image/png"
              action
              :auto-upload="false"
              :show-file-list="false"
              :multiple="false"
              :limit="101"
              :on-change="handleAvatarSuccess"
              :disabled="disabled.image"
            >
              <img
                v-if="dataModel.userProfile.image"
                :src="dataModel.userProfile.image"
                class="avatar"
              />
              <i v-else class="el-icon-plus avatar-uploader-icon" />
            </el-upload>
            <el-button
              icon="el-icon-edit-outline"
              style="margin-left:190px;"
              class="slot-input"
              @click="disabledAction('image')"
            />
          </el-col>
        </el-row>
      </el-form-item>

      <el-form-item label="用戶ID" prop="users.username">
        <el-input v-model="dataModel.users.username" placeholder="用戶ID" style="max-width:300px;">
          <el-button slot="append" icon="el-icon-search" type="primary" @click="findByUserId" />
        </el-input>
      </el-form-item>
      <el-form-item label="用戶姓名" prop="userProfile.name">
        <el-input
          v-model="dataModel.userProfile.name"
          placeholder="用戶姓名"
          style="max-width:300px;"
          :disabled="disabled.name"
        >
          <el-button slot="append" icon="el-icon-edit-outline" @click="disabledAction('name')" />
        </el-input>
      </el-form-item>
      <el-form-item label="EMAIL" prop="userProfile.email">
        <el-input
          v-model="dataModel.userProfile.email"
          placeholder="EMAIL"
          style="max-width:300px;"
          :disabled="disabled.email"
        >
          <el-button slot="append" icon="el-icon-edit-outline" @click="disabledAction('email')" />
        </el-input>
      </el-form-item>
      <el-form-item label="所屬部門" prop="userProfile.department">
        <el-select v-model="dataModel.userProfile.department" :disabled="disabled.department">
          <el-option label="資訊部" value="MIS" />
          <el-option label="人力資源部" value="HR" />
        </el-select>
        <el-button
          icon="el-icon-edit-outline"
          style="color:purple;"
          class="slot-input"
          @click="disabledAction('department')"
        />
      </el-form-item>
      <el-form-item label="性別" prop="userProfile.sex">
        <el-radio-group v-model="dataModel.userProfile.sex" :disabled="disabled.sex">
          <el-radio-button :label="1">男</el-radio-button>
          <el-radio-button :label="0">女</el-radio-button>
        </el-radio-group>
        <el-button
          icon="el-icon-edit-outline"
          style="color:purple;"
          class="slot-input"
          @click="disabledAction('sex')"
        />
      </el-form-item>
      <el-form-item label="狀態" prop="users.enable">
        <el-radio-group v-model="dataModel.users.enable" :disabled="disabled.enable">
          <el-radio :label="true">開啟</el-radio>
          <el-radio :label="false">鎖定</el-radio>
        </el-radio-group>
        <el-button
          icon="el-icon-edit-outline"
          style="color:purple;"
          class="slot-input"
          @click="disabledAction('enable')"
        />
      </el-form-item>
      <el-form-item label="權限" prop="roles">
        <el-checkbox-group v-model="dataModel.roles" :disabled="disabled.roles">
          <el-checkbox-button v-for="(i,index) in roles" :key="index" :label="i.role">{{ i.name }}</el-checkbox-button>
        </el-checkbox-group>
        <el-button
          icon="el-icon-edit-outline"
          style="color:purple;"
          class="slot-input"
          @click="disabledAction('roles')"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" :disabled="buttonDisabled" @click="settingAction">更新</el-button>
        <el-button type="primary" :disabled="buttonDisabled" @click="resetAction">重置</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>
<script>
import { query as roleQuery } from '@/api/role'
import { findByUserId, setting } from './action'
import { Message } from 'element-ui'
export default {
  data() {
    return {
      buttonDisabled: true,
      roles: [],
      dataModel: {
        userProfile: {
          name: '',
          email: '',
          sex: '',
          department: '',
          image: ''
        },
        users: {
          username: '',
          enable: ''
        },
        roles: []
      },
      originalDataModel: {
        userProfile: {},
        users: {},
        roles: []
      },
      disabled: {
        name: true,
        email: true,
        sex: true,
        department: true,
        image: true,
        enable: true,
        roles: true
      },
      defaultDisabled: {
        name: true,
        email: true,
        sex: true,
        department: true,
        image: true,
        enable: true,
        roles: true
      }
    }
  },
  mounted() {
    this.roleQueryAction()
  },
  methods: {
    roleQueryAction: function() {
      roleQuery().then(res => {
        if (res.status === 'OK') {
          this.roles = res.data
        }
      })
    },
    settingAction: function() {
      setting(this.dataModel).then(res => {
        if (res.status === 'OK') {
          Message({
            message: '更新成功!',
            showClose: true,
            type: 'success'
          })
        } else {
          Message({
            message: res.message,
            showClose: true,
            type: 'error',
            dangerouslyUseHTMLString: true
          })
        }
      })
    },
    findByUserId: function() {
      if (this.dataModel.users.username.trim().length === 0) {
        Message({
          message: '用戶ID不能為空!',
          showClose: true,
          type: 'error'
        })

        return
      }

      findByUserId(this.dataModel.users.username).then(res => {
        if (res.status === 'OK') {
          this.dataModel = res.data
          this.originalDataModel = JSON.parse(JSON.stringify(res.data))
          this.buttonDisabled = false
          Message({
            message: '查詢成功!',
            showClose: true,
            type: 'success'
          })
        }
      })
    },
    disabledAction: function(ele) {
      this.disabled[ele] = !this.disabled[ele]

      if (this.dataModel.userProfile[ele] !== null) {
        this.dataModel.userProfile[ele] = this.originalDataModel.userProfile[
          ele
        ]
      }

      if (this.dataModel.users[ele] !== null) {
        this.dataModel.users[ele] = this.originalDataModel.users[ele]
      }

      if (ele === 'roles') {
        this.dataModel.roles = this.originalDataModel.roles
      }
    },
    resetAction() {
      this.$refs.dataModel.resetFields()
      this.originalDataModel = { userProfile: null, users: null, roles: [] }
      this.disabled = Object.assign({}, this.defaultDisabled)
      this.buttonDisabled = true
    },
    handleAvatarSuccess: function(file, fileList) {
      const isLt2M = file.raw.size / 1024 / 1024 < 2
      const isJPG =
        file.raw.type === 'image/jpeg' || file.raw.type === 'image/png'
      if (!isJPG) {
        this.$message.error('上传头像图片只能是 JPG 或 PNG 格式!')
        return false
      }

      if (!isLt2M) {
        this.$message.error('上传头像图片大小不能超过 2MB!')
        return false
      }
      const reader = new FileReader()
      reader.readAsDataURL(file.raw)
      reader.onload = () => {
        this.dataModel.userProfile.image = reader.result
      }
    }
  }
}
</script>
<style>
.avatar-uploader .el-upload {
  border: 3px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
}
.el-input-group__append,
.el-input-group__prepend {
  color: purple;
  background-color: aquamarine;
}
.slot-input,
.slot-input:hover {
  color: purple;
  background-color: aquamarine;
}
</style>
